Internationalization

Internationalization

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In daily life global acting and thinking is decisive.

Efficient, ergonomic, international ... these are only three keywords that represent the zenon philosophy and meet this challenge.

This tutorial will show you using specific problems how in your familiar environment you can adapt your project to international business domains with a minimum effort. From the language or unit adaptation to the visual appearance. This tutorial is enhanced with practical tips and references to possible sources of error.

Example of use:

  • Delivering a project in different languages
  • Multilingual operation of a facility
  • Adapting measuring units to the local environment
  • Different display options of the user interface
  • Adapting to specific conditions
  • Accessibility

Other topics in this chapter

Requirements

Project Settings

Configuration of the language change

Language-changeable graphics

Converting units

Applying the wizard to existing projects

Translation assistance Project Translation Interface

Message Control (subject to license)

Application opportunities of the language change

Summary


Requirements

Internationalization -> Requirements

A little zenon basic knowledge is required for this tutorial. Therefore it is recommended for beginners and inexperienced users to first work through the Basic tutorial. Some important project settings of this tutorial are explained step by step, but they aren't described in detail.

Other topics in this chapter

Preparations for this tutorial

Runtime operation


Preparations for this tutorial

Internationalization -> Requirements -> Preparations for this tutorial

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

If you already have some basic knowledge of the zenon Editor you can skip this chapter.

A neutral project and a neutral screen are created.

Parameters | Description
Name of the workspace | Tutorials_Workspace
Project name | INTERNATIONAL
Project type | Standard project
Screen name | Main
Variable name 1 | Filling level
Variable name 2 | Temperature
Variable driver | Internal - Driver for intern variables
Variable type | INT

Other topics in this chapter

Creating a new workspace

Creating a new project

Create screen

Creating two variables


Creating a new workspace

Internationalization -> Requirements -> Preparations for this tutorial -> Creating a new workspace

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In this step you will carry out preparations for the configuration of the individual tutorial steps. You will

  • create a workspace
  • create a project
  • create drivers
  • Create variables

First, create a neutral environment by creating a new workspace with a new project.

To create a new workspace proceed as follows:

  1. In the menu File select the command New workspace...
  2. Name the workspace Workspace_International


Creating a new project

Internationalization -> Requirements -> Preparations for this tutorial -> Creating a new project

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

To create a new project proceed as follows:

  1. In the menu Fileselect the command Project new..
  2. Select the project type Standard project
  3. Name your project INTERNATIONAL
  4. The project is now automatically created and the zenon Project Wizardwill open
  5. Close the wizard with the Closebutton
  6. Confirm the dialog Form Closing by clicking No

info Information

A neutral environment is now available for the next tutorial steps.


Create screen

Internationalization -> Requirements -> Preparations for this tutorial -> Create screen

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

  • In the project manager, open the nodeScreens.
  • Select New screen
  • Go to the properties window and select the entry General.
  • Name the screen Main.

info Information

The tutorial project now has a (still empty) screen


Creating two variables

Internationalization -> Requirements -> Preparations for this tutorial -> Creating two variables

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

This tutorial refers to two values. Temperature and filling quantity are adapted to the corresponding units of a country.

To do so, two variables are required. To create two variables:

  1. In the project manager, open the nodeVariable.
  2. Create a variable in the detailed view with the command Variable new...
  3. In the dialog window Create variable select the entries
    • Internal - Driver for internal variables as Driver
    • Internal variable as Driver-Object type
    • INT as D ata type of the variable
    • Filling quantityas Name
  4. Confirm the entry by clicking Complete
  5. Create a second variable called Temperature (rest see above)


Runtime operation

Internationalization -> Requirements -> Runtime operation

In this tutorial you will repeatedly be asked to start the Runtime. When doing so, don't forget to create the corresponding Runtime files in the COPA-DATA Editor.

In order to create Runtime files use

  • keyboard shortcuts
  • Tool bar

Usage of keyboard shortcuts:

Parameters | Description
F7 | Create changed Runtime files.
F5 | Starts Runtime.
Alt+F4 | Ends Runtime.
attention Attention
Between the individual tests you should always end the Runtime. To do so, use the shortcut Alt+F4.

Usage of the toolbar

Use the symbols

  • Create changed Runtime files in order to save.
  • Start Runtime in order to check the configuration in the Runtime.

If this toolbar is not displayed in your Editor activate it:
Menu bar Options => Toolbar => Runtime files


Project Settings

Internationalization -> Project Settings

In the zenon Editor and Runtime it is possible to have the keywords which are to be translated displayed.

  1. Open the project settings by clicking on the project name International.
  2. Click on the properties in the menu item Graphical shapes,
  3. Runtime general.
  4. Activate the property Display not translated keywords.

info Information

This selection determines if in the Runtime keywords are displayed in the translated version or in the "source language" with an @ in front.

Other topics in this chapter

Keywords in the Editor

Displaying key words in the Runtime

Using the zenon internal language files


Keywords in the Editor

Internationalization -> Project Settings -> Keywords in the Editor

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Have a look around the zenon Editor. For instance, if you click on the node Screens and look at the detailed view you will discover an @-symbol in front of the column headlines (after activating the keyword view).

Click on different nodes in the project manager and look at the headlines of the detailed view.

info Info

Now you know how to show and hide translatable texts.

Note:
In the Editor keywords with already existing translations are shown without the @

.


Displaying key words in the Runtime

Internationalization -> Project Settings -> Displaying key words in the Runtime

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Now have a look at your project created up to now in the Runtime.

  • If a keyword is linked to a translation, the translated text is displayed in the Runtime.
  • If a keyword is not linked to a translation, no text is displayed in the Runtime.
  • Texts which are not yet translated can be displayed as keyword.

Note: Please keep in mind that this @-symbol is only displayed during the first start of the Runtime. After the first language switch or a Reload of the Runtime these symbols are hidden.


Using the zenon internal language files

Internationalization -> Project Settings -> Using the zenon internal language files

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

You will now learn how to use zenon internal keywords:

Example of use:

  • Searching for missing or incorrect translations
  • Using zenon resources for your configuration
  • Using existing (and already translated) dialogs for your project
  • Visualization of variable names in the zenon Runtime

The terms used in zenon are not integrated by default into the language file. You can request a language file from support@copadata.com. At present, the resources are available in the following languages:

  • Chinese (simplified)
  • English
  • French
  • Italian
  • Russian
  • Spanish
  • Czech

info Information

In practice, you will rarely have activated the property Display not translated keywords. This is also the reason why this property is always deactivated when creating a new project.


Configuration of the language change

Internationalization -> Configuration of the language change

The following steps will show you how easy it is to create language-changeable texts in zenon:

  • The term filling level is supposed to be language-changeable.
  • It is desired to be able to change between German and Portuguese.

Other topics in this chapter

Translation tables with keyword & keyword

Function Language switch

Add further languages

Simulating the language change in the Editor

Using the @-symbol

Font lists and length of text


Translation tables with keyword & keyword

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

You will learn how to configure languages and words to be translated with the following steps. In order to do this the following steps are necessary:

  1. Create language file
  2. Managing keywords
  3. Create function
  4. Apply function

Other topics in this chapter

Create language file

Managing keywords


Create language file

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Create language file

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Create a language file in order to be able to fill texts marked as language-changeable with the translation.

  1. In the project manager, open the nodeLanguage file
  2. select Language file new...
  3. enter the name of the new language file
    (in this example PORTUGUESE.TXT)
    Note: naming the language files is automatically carried out in capitals
  4. confirm by clicking on the Save button

Other topics in this chapter

Practical tips for language files

The meaning of the language file ZENONSTR.TXT

Interesting facts of the language file


Practical tips for language files

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Create language file -> Practical tips for language files

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Stick to simple and international standards when naming the language tables. Keep in mind that also project partners will be working with them who don't know your language (e.g. translators, administrators on site). From the beginning on, opt for a standard you can also apply in later extensions.

Example Examplee
  • Name your language tableGerman instead ofDeutschland and/or Deutsch

or ...

  • use internationally valid terms such as D, USA, GB, JP ...

info Info

Clear and efficient naming of language files make a cooperation easier and increase efficiency.

Various language files in different projects

If you use various language files - e.g. global projects or projects with integrated projects - remember to use different names.

Otherwise it is difficult to recognize which language file must be imported into which project when using the export and import function for the translation of a language file.

Example Example

TUTORIAL-PORTUGUESE instead of Portuguese

Information

Exact designations make the allocation in Global Projects easier.

Avoiding language-dependent characters

When naming language tables avoid language-dependent special characters in order to optimize the cooperation with international partners.

Examples for language-dependent special characters:

öäüß in German-speaking countries

øåæ in Scandinavian countries

Of course the contents of the language tables - i.e. the translations - may contain special characters!

Information

In projects with cross-country and -language cooperations language-dependent characters in the naming of language tables and entries of the keywords may lead to misunderstandings between the project partners!


The meaning of the language file ZENONSTR.TXT

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Create language file -> The meaning of the language file ZENONSTR.TXT

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In zenon the entries of the column keywords are used for configuring the language change. The language file ZENONSTR.TXT refers to the zenon setup language defined on the executing computer.

Individual language file for mother tongue

Under certain circumstances it can make sense to also create an individual language table for your "mother tongue" in the configuration. In particular if you are working together on a project with foreign colleagues (keyword: global and network project). In this case ZENONSTR.TXT is location-dependent.


Interesting facts of the language file

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Create language file -> Interesting facts of the language file

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  • It is possible to insert a language file at any time. It is possible to unproblematically insert one at a later point of time. In this way, you can easily adapt your existing projects to a new language region if your business expands!
  • Sorting the keywords takes place automatically with every request of the node Language file.
  • Clicking on the headline will sort the list again.


Managing keywords

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Managing keywords

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The larger your project gets the more words will be displayed in several languages. Managing this is done with keywords.

  1. In the project manager open the node Language file
  2. Place the cursor in the last row of the column Keyword.
  3. Enter the keyword to be translated Filling level.
  4. Confirm the entry with the enter key (the cells of the remaining language files are pre-filled with this entry).
  5. Enter the translation in the corresponding column of your language file.
    (In our example nível in the column TUTORIAL-PORTUGUESE.TXT.
  6. Enter the termTemperaturewith the corresponding translation temperatura.

Other topics in this chapter

Integrating foreign special characters

Practical tips for keywords


Integrating foreign special characters

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Managing keywords -> Integrating foreign special characters

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

You might have noticed it in our example: the Portuguese translation of filling quantity is nível.

Look closer at the dot on the i: The Portuguese alphabet uses so-called diacritical signs. There is not always a dot in Portuguese above the lower case letter í - there is sometimes an accent instead.

So what can you do if the configuration must be in Portuguese but you don't have a Portuguese keyboard at hand?

The solution is very simple:

  1. In the project manager, open the node Language file.
  2. In the language change toolbar, select the symbol Character table...

  3. The Windows character table will open.
  4. Select the required character
  5. The button Copycopies the selected letter to the clipboard.
  6. Change back to the Editor. Paste the letter with Ctrl+V to the desired position.

info Information

If the desired letter is not visible change the character set.

§§ Trenner

Example Example

Russian letters are in the Windows character set: Cyrillic


Practical tips for keywords

Internationalization -> Configuration of the language change -> Translation tables with keyword & keyword -> Managing keywords -> Practical tips for keywords

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

These tips serve to help you to efficiently configure language-changeable texts in zenon as well as to minimize errors in advance:

Correct completion of the entry of a keyword

Always complete the entry of every single keyword with the enter key.

Background:
In many computer programs it is standard practice to go to the next entry box with the tab key. This function is not supported in the language file! On the contrary, this approach has a high potential for errors since the tab key does not go to the next box but actually sets the tab key as (invisible) content!

Adapting to country-specific language differences

You can also use the language change function for national terms of one language family. As an example, the differences between British and American English are listed below.

Example comparison British and American English
GB | USA
colour | color
modelling | modeling
licence | license

Configured keyword = entry in the language table

Make a habit of immediately creating an entry of configured keywords in the language table.

If the translation is not available yet, for instance an international language from the business environment of your company (e.g. English, French, Spanish, Russian, ...) can be entered as pre-translation.

It is also possible to use hybrid forms. However, keep the additional management effort and increased risk of errors in mind.

"Foreign-language" keywords

In projects in which employees with different mother tongues are working together it is recommended to create the keywords in a standard language.


Function Language switch

Internationalization -> Configuration of the language change -> Function Language switch

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Using the already created language files and keywords takes place with the help of a zenon function. To do so, the following two steps have to be taken:

  1. Create function
  2. Apply function

Other topics in this chapter

Function Create language switch

Apply function


Function Create language switch

Internationalization -> Configuration of the language change -> Function Language switch -> Function Create language switch

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

One function must be created once for every language:

  1. In the project manager, open the node Functions.
  2. Select Function new...
    The function selection box will open
  3. Select the application function Language change

  4. In the dialog now open select the language file by clicking ...
  5. In the next dialog select TUTORIAL-PORTUGUESE.TXT
  6. Confirm your entry with OK
  7. Name this function Language_portuguese in the properties window.
    To do so, in the properties window go to the node General.
  8. Repeat the step described above for your system language.
    Name this language change function Language_native. Select ZENONSTR.TXT as language file.

Note: The file to be linked ZENONSTR.TXT always contains the language your system is set to. If you work with zenon on an operating system in German language, in our example link point 8 of the above instruction with ZENONSTR.TXT.

The advantage:

This function only has to be created once for every language!

Any time you'd like to use the language change, link the existing function with the corresponding element (e.g. button, screen element, ...). You only have to make sure then that there is an @-symbol in front of the keyword in the configuration and that this keyword is also stored in the language file.

info Info

Now you know how you can create a function for language change in your project.


Apply function

Internationalization -> Configuration of the language change -> Function Language switch -> Apply function

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  1. Put the previous steps together in order to make your translation visible and applicable in the Runtime.

In order to activate the language change, put them on two buttons Native and Portuguese.

  1. Open the Main screen.
  2. Select Elements => Buttonfrom the menu bar
  3. Draw a button in the Main screen
  4. Select the Language_Portuguese function
  5. In the properties window in the property group Displayenter Text line1:in the box . Portuguese on.
  6. Repeat steps 1 to 4 and use the function for language change to your system language (zenonstr.txt).
    In a previous step this function has already been created and named Language_native.

Other topics in this chapter

Insert text boxes

First test in the Runtime

Displaying language as text

Practical hints for the Language change function


Insert text boxes

Internationalization -> Configuration of the language change -> Function Language switch -> Apply function -> Insert text boxes

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Since you now know the preparatory steps to take, apply the language table in a screen with two texts:

  1. In the project manager, open the node Screens
  2. Select the screen Main
  3. Open the screen by double-clicking Main
  4. From the menu bar Elements => select Static text
  5. In the screen Main draw the text box

  6. In the properties window, in the propertyText enter@filling level
  7. Repeat steps 4 to 6 with the term Temperature
    (im the properties window @Temperature must be entered)

info Information

The @-symbol is an indicator for language-changeable texts!


First test in the Runtime

Internationalization -> Configuration of the language change -> Function Language switch -> Apply function -> First test in the Runtime

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Now you can test the configured language change in the Runtime:

  • The current Runtime files are created with the F7 key.
  • The Runtime is started with the F5 key.

Depending on the positioning of your text box and buttons the Runtime view should look similar. By clicking on the language buttons the texts should change between both languages.

info Information

The Runtime can be ended with the shortcut ALT + F4.


Displaying language as text

Internationalization -> Configuration of the language change -> Function Language switch -> Apply function -> Displaying language as text

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

This example shows how to display the corresponding project language as texts in multilingual projects.

The following steps are required - in addition to the previous configuration:

  1. translate a keyword
  2. make the keyword language-changeable by placing an @-symbol in front
  3. place a text box in your screen

This is configured as follows:

  1. In the project manager, open the nodeLanguage file
  2. enter a new keyword: Language
  3. In the corresponding language, enter the terms native (in the column ZENONSTR.TXT) and portuguese (in the corresponding column) instead of a literal translation
  4. In the project manager change to the node Screens.
  5. Place anElement Static Text and enter Text box @Language in the display properties in the entry box
  6. Start the Runtime (F5)

Note: The keyword is not translated in its original way but rather serves as a wild-card character. In this example, the translation represents the translation language.

info Information

Now you know how to display the selected language as text


Practical hints for the Language change function

Internationalization -> Configuration of the language change -> Function Language switch -> Apply function -> Practical hints for the Language change function

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  • Always create a new language table if you create a function language change and vice-versa.
  • Give your function an unambiguous name.
  • Always put a prefix in front of all language change functions when naming them (e.g. Language_ ..., Switch_to_ ...).
  • In order to optimize the clarity in the detailed view Functions use filter texts and sorting.


Add further languages

Internationalization -> Configuration of the language change -> Add further languages

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In the following steps Polish is added as a further language to the existing project.

The following steps are required:

  • Create language file
  • Enter keywords
  • Create function

  1. Create a new language file:
    1. In the project manager, open the node Language file.
    2. Create a new language file and name it TUTORIAL-POLISH
    3. Complete this new language file with the corresponding translations (filling level: poziom, temperature: temperatura)
  2. Create a new function:
    1. In the project manager, open the node Functions
    2. Create a new function with Function new
    3. In the function selection window in the node Applicationselect the entry Language change
    4. Select the allocation by clicking the button ... and selection of TUTORIAL-POLISH.txt
    5. Name this function Language_polish
  3. Link function
    1. Open the screen Main by double-clicking it
    2. Select Elements => Buttonfrom the menu bar
    3. Draw a button
    4. select the Language_polish function
    5. In the properties window in the display properties add text row 1 in the text box: Polish
    6. Test the newly configured language change for Polish in the Runtime (F5).

info Info

The Runtime can be ended with the shortcut ALT + F4.


Simulating the language change in the Editor

Internationalization -> Configuration of the language change -> Simulating the language change in the Editor

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

It is possible to already simulate the first effects of a language change during the configuration in the Editor. This step is particularly helpful for making different lengths of texts visible already during the configuration in the Editor. The dialog language of the Editor remains unchanged.

To do this:

  1. In the project manager open the node Language file
  2. Select Language file for Editor in the context menu or the symbol bar and select the corresponding language.
    The labeling is analogous to the names of the language tables.
    The lowest entry of the drop-down list active activates the functionality (in case of an active checkbox) or deactivates it (entries are gray).

info Information

You can have your configuration displayed directly in the Editor in the selected language with the selection language file for Editor. The selected language file is marked with a green headline.

Editor view with selected language table


Using the @-symbol

Internationalization -> Configuration of the language change -> Using the @-symbol

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The @-symbol is an indicator that the following text is supposed to be language-changeable.
After creating the corresponding translation in the language table (seeManaging keywords) these translations are available.

In practice, there will be multiple uses of one keyword. In this case only enter the keyword used once in the language table.

Other topics in this chapter

Rules for using the @-symbol

Examples with compound words


Rules for using the @-symbol

Internationalization -> Configuration of the language change -> Using the @-symbol -> Rules for using the @-symbol

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Keywords are marked by the @-symbol For this, the following applies:

@Text

The whole text will be translated.

Text

This text will not be translated.

@Text

The text between the two “@” will be translated.

The following is true: After an odd number of “@” the text will be translated (start counting at the beginning of the entry).

For example: @user@Doe

  • user is translated
  • Doe is not translated

Linking

It is possible to link text elements which are to be translated with those which are not to be translated.

Example Example

@The user@ Doe @is logged out.

@Text1@ Text2 @Text3
  • Text 1: will be translated
  • Text 2: will not be translated
  • Text 3: will be translated


Examples with compound words

Internationalization -> Configuration of the language change -> Using the @-symbol -> Examples with compound words

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Already existing keywords can also be used in combination.

Task description:

The following terms should be localizable and be displayed in menus:

  • Light on
  • Air conditioning on

The translation is:

  • lâmpada ligado
    (Light on)
  • ar condicionado ligado
    (Air conditioning on)
  • lâmpada desligado
    (Light off)
  • ar condicionado desligado
    (Air conditioning off)

Other topics in this chapter

The easy way

The elegant way

Menus and Web Server

Making menus visible in the Runtime


The easy way

Internationalization -> Configuration of the language change -> Using the @-symbol -> Examples with compound words -> The easy way

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The easiest way in this example is to enter the text into the language table as follows:

@Light on

@Air conditioning on

In the language table, in our example the terms "light on" and "air conditioning on" would be translated with both words independently of each other.


The elegant way

Internationalization -> Configuration of the language change -> Using the @-symbol -> Examples with compound words -> The elegant way

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

However, it is much more efficient to combine already translated (individual) words. The more extensive your project is the bigger synergies you will get!

  1. Add the new keywords to your language file ZENONSTR.TXT:
    1. Light
    2. Air conditioning
    3. on
    4. off
    5. Control
  2. Add the translations to the language file TUTORIAL-PORTUGUESE.TXT:
    1. lâmpada
    2. ar condicionado
    3. ligado
    4. desligado
    5. controle

Attention:

Work calmly and concentratedly. In this case, every space and its placing counts.
@Light@ @on is not the same as @Light@@ on. Observe the rules as described in the chapter "Rules for using the @-symbol".


Menus and Web Server

Internationalization -> Configuration of the language change -> Using the @-symbol -> Examples with compound words -> Menus and Web Server

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

It is just as simple to create language-dependent menus as to create elements. In this example, only menus for displaying text switching are created. Linking the menu entries with a variable is intentionally omitted.

  1. In the project manager, open the node Menus.
  2. In the the tool bar of the detailed view select Main menu new
  3. Name the newly created main menu Main
    1. To do so, in the node of the menu properties click on the first entry.
    2. Enter the name Main in the text box in the properties window.
      The text box is in the node Display / Type.
  4. In the cross-reference list click in the first box (left corner above) and create the entry @Control
  5. Fill the boxes below with the entries
    @Light@ @on
    @Light@ @off
    @air conditioning@ @on
    @air conditioning@ @off

Note:
In the Web Server the language change is not available in the menu function!


Making menus visible in the Runtime

Internationalization -> Configuration of the language change -> Using the @-symbol -> Examples with compound words -> Making menus visible in the Runtime

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Before you'll be able to use your language-changeable menus in the Runtime you have to activate them in the Editor. This takes place with the help of a function.

  1. In the project manager, open the node Functions.
  2. Select Function new...
  3. Select
    1. the screen function
    2. Display menu

  4. In the dialog box now open select
    1. Display menu and
    2. Main as menu
  5. Name this function in the properties window Show_Menue

Finally, in the screen Main draw another button and apply the newly created function.

After having taken these preparatory steps apply the created menu to a button:

  1. In the project manager, open the nodeScreens.
  2. Select the screen Main
  3. Open the screen by double-clicking Main
  4. Select Elements => Buttonfrom the menu bar
  5. In the opening window
    1. Functions selection
    2. select the Show_Menue function
  6. Name the button Display menu.
    To do so, in the properties window change to the node Displayand enter the text in the box Text Zeile 1:.

info Information

If you also enter the term "Display menus" in your language table this button is also displayed depending on the language. Accordingly, place an @-symbol in front of the button labeling.

The translation is: Mostrar menu

Test your entries in the Runtime.


Font lists and length of text

Internationalization -> Configuration of the language change -> Font lists and length of text

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

If you have followed this tutorial step by step you might already have noticed: different languages have different lengths of texts.

In particular, this makes it difficult to label buttons. Due to the limited space texts might be cut off.

A very simple and efficient solution is to use a smaller font size for longer texts. To do so, zenon makes the functionality of font lists available.

Other topics in this chapter

Font lists

Working with font lists

Default font(s)

Configuration of the font list switching

Practical tips for designing different text lengths


Font lists

Internationalization -> Configuration of the language change -> Font lists and length of text -> Font lists

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

When using font lists not every font has to be set with size, type, cut, code and effect individually for every text or labeling.

Another advantage: Changes in a font list object are automatically applied to the entire configuration.

Foreign-language character sets:

Font lists are also used for foreign-language character sets. For Asian, Cyrillic or Arabic characters it is thus possible to display letters of the corresponding alphabet. It is also possible to display language-dependent special characters.


Working with font lists

Internationalization -> Configuration of the language change -> Font lists and length of text -> Working with font lists

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

To create a font list proceed as follows:

  1. In the node Screenschange to Font lists
  2. Create a new font list with the button New font list.
  3. For a better orientation, name the created font list.
    In this example: Language_portuguese
  4. Change the respective font.
    In order to make this configuration visible in the Runtime, select a font type that significantly differs, such as Vladimir Script.

attention Attention

The changes must be made individually for each font.


Default font(s)

Internationalization -> Configuration of the language change -> Font lists and length of text -> Default font(s)

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Contents from the toolbar elements are given default values.

In order to change the default settings, proceed as follows:

  1. In the node Screens change to Font lists.
  2. Go to the line with the corresponding font.
  3. Click ... next to the property Font type in the properties window in order to open the font type window.
  4. Change the font settings to your requirements.

Configuration of font lists:

  • Standard font2 (Position 2) for text elements inzenon
  • Button- (Position 6) usually for naming the button element

info Information

Note that changing font type or size will have effects on your previous configuration.


Configuration of the font list switching

Internationalization -> Configuration of the language change -> Font lists and length of text -> Configuration of the font list switching

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Font list switching is also carried out with the function Language change. Please note: Create a function, which can be used any number of times, for every font list.

If you have already created a function for language change you can use it. You only have to indicate the corresponding font list in the function.

Other topics in this chapter

Creating the function for font switching

Font switching in case of existing language change function


Creating the function for font switching

Internationalization -> Configuration of the language change -> Font lists and length of text -> Configuration of the font list switching -> Creating the function for font switching

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The following steps will explain how to create a function for switching between individual font lists. Changing a language file is intentionally omitted in this case.

  1. In the project manager, open the node Functions.
  2. Select Function new...
    The function selection box will open.
  3. In the application folder select Language change.

  4. In the dialog box that now opens select the font list by clicking on the drop-down menu Font list
  5. Select Language_portuguese in the Font list.
  6. Confirm your entry with OK
  7. Name this function Font_list_portuguese in the properties window.
    To do so, go to the General node in the properties window.
  8. Repeat the step described above for your system language.
    To do so, select Font list1 . name this function Font_list_native.


Font switching in case of existing language change function

Internationalization -> Configuration of the language change -> Font lists and length of text -> Configuration of the font list switching -> Font switching in case of existing language change function

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

If you have already created a function for language change you can use it. You only have to indicate the corresponding font list in the function.

The following steps build on the previous tutorial steps:

  1. In the project manager, open the node Functions.
  2. Select the existing function Language_portuguese.
  3. In the properties window of the function select Language_portuguese
  4. Confirm the entry with OK.
  5. Name this function Language_portuguese in the properties window.
    To do so, in the properties window go to the node General.
  6. Repeat the step described above for your system language.
    Name this language change function Language_native. Select ZENONSTR.TXT as language file.


Practical tips for designing different text lengths

Internationalization -> Configuration of the language change -> Font lists and length of text -> Practical tips for designing different text lengths

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

During the configuration keep in mind that words may differ in length in different languages.

The following suggestions may help you to master this task:

  • Configure an individual font list for every language:
    z. B.: Button english big, Button italian big.
  • Configure several font lists for every field of application:
    z. B.: Button font large / button font small.
  • Configure your font lists with a larger font size:
    z. B.: Button font two points larger than usual in order to adapt longer fonts occurring at a later time by only correcting the font size once.

Recommendation: Use one of these steps already at the start of the configuration. Even if the project at first is only supposed to be available in two languages you will save additional adaptations during later extensions.

Practice examples for different text lengths

German | English | Italian
ein | on | innestato
aus | off | OFF

Foreign language characters

Note: Not every font contains the required characters or symbols. If you configure an Asiatic or Cyrillic font select a font containing the required special characters.

For this reason, keep in mind to use a font which contains foreign-language character sets already during the configuration.

Example Example

The font Arial Unicode MS offers a selection of the most common font scripts.

Note for shortcuts

Note when assigning keyboard shortcuts to international identifications, similar to the already-familiar system in applications (ALT+P for Print instead of ALT+D for Drucken, the German word for print).

Note: The keyboard shortcuts are configured in the element settings in the Runtime node in the keyboard shortcut input field.

Additional benefit of the language change

A further application option of the language change is the adaptation of the textual appearance to external circumstances. Changing the language not necessarily has to result in a second language:
Examples:

  • Bolder font for a high-contrast display
  • Change of font color to avoid problems due to red-green visual impairments.


Language-changeable graphics

Internationalization -> Language-changeable graphics

In the following section the language change is displayed graphically with the corresponding flag.

Other topics in this chapter

Language-changeable graphics - file system

Language-changeable graphics - Preparation

Configuration of language-changeable graphics

Practical tips Switching graphics


Language-changeable graphics - file system

Internationalization -> Language-changeable graphics -> Language-changeable graphics - file system

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In contrast to texts graphics do not have to be separately marked as language-changeable. The allocation is carried out on the file level with the help of standardized indices (predetermined by zenon).

In order to understand this principle note the following:

  1. In a neutral and empty project open the node Files.
  2. Click on the node Graphics.

    Note: Observe the empty content of this folder

  3. Change to the node Language file and create a New language file.
  4. Name the new language file TUTORIAL-PORTUGUESE.
  5. Change back to the node Files:
    The first thing you will notice is that the folder graphics contains subfolders (recognizable by the prefixed[+]).
  6. Open the folder Graphics by clicking[+].
  7. For a better understanding we will now add a third language
  8. Expand the view of the node Filesso that the folders Files and Graphics are opened.
  9. Now click once in the node on the entry Language file
  10. Keep an eye on the folder Files while you are configuring the following:
    1. create a new language table
    2. name it with TUTORIAL-POLISH
    3. and confirm this entry with OK.

When the language change function is carried out the graphic is automatically loaded into the Runtime from the corresponding folder.

info Information

If a language table is deleted the subdirectories in the node Files are maintained.


Language-changeable graphics - Preparation

Internationalization -> Language-changeable graphics -> Language-changeable graphics - Preparation

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

After having been introduced to the principle of changeable graphics now configure the task.

Preparation:

You should have one screen with the corresponding country flag for each language ready for the next steps.

  1. In the node Language change create two new language files and name these TUTORIAL-PORTUGUESE.TXT and TUTORIAL-POLISH.TXT.
  2. Change to the screen Main.
  3. Draw a button and confirm the following dialog without selecting a function with OK.
  4. In the properties windows in Display select the property Graphic file and select the button ...
  5. In the dialog now open select Import file...

  6. In the file browser now open select the graphic file (country flag) corresponding to your language.


Configuration of language-changeable graphics

Internationalization -> Language-changeable graphics -> Configuration of language-changeable graphics

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

After you have created a project in your language and have added a corresponding graphic now the foreign-language graphics will be added.

This is a two-step process:

  1. Upload the graphic in the corresponding folder
  2. Customizing the language change function

Other topics in this chapter

Uploading graphics into file folders

Customizing the language switch function


Uploading graphics into file folders

Internationalization -> Language-changeable graphics -> Configuration of language-changeable graphics -> Uploading graphics into file folders

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Follow the usual steps for uploading graphics in zenon:

  1. Open the node Files.
  2. In the structural point Graphics click on the folder TUTORIAL-PORTUGUESE.
  3. Upload the corresponding graphic with the command Import file....
  4. Repeat this step with the graphic for the Polish language.

attention Attention

The file naming of the images must be identical in all languages in the language change.


Customizing the language switch function

Internationalization -> Language-changeable graphics -> Configuration of language-changeable graphics -> Customizing the language switch function

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

If you create a language change function you will be able to test the configuration of your language-dependent graphic conversion in the Runtime.

  1. In the project manager, open the node Functions.
  2. Select Function new...
    The function selection box will open.
  3. Select the Language change function.
  4. In the dialog box now opened, select Graphics by clicking on the drop down list.

  5. select TUTORIAL-PORTUGUESE.
  6. Confirm the entry with OK.

info Information

Of course, you can add the assignment of the graphic to an already configured function.


Practical tips Switching graphics

Internationalization -> Language-changeable graphics -> Practical tips Switching graphics

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  • As already mentioned: a standard denomination makes the configuration easier. Since in the case of switching graphics the graphic name is decisive you should (by way of exception) avoid naming the country in the file name. Instead, add a term like flag_language identification to the graphic name.
  • The language change option can not only be used for the "translation" of graphics. Another application is the option of two user interfaces, e.g. in order to counteract external influences such as sun rays.
  • A further application example for changeable graphics is the option of visualizing country-specific company logos in your HMI-system.
  • Even if you only operate in one language region: use this function for your purposes. For instance, it is possible to graphically denote individual plants (also in one country) with this function.


Converting units

Internationalization -> Converting units

Not only language but also units depend on the regions. With zenon you are perfectly equipped for this task.

Other topics in this chapter

Configuration of the value conversion

Scripts for summarizing several functions

Value conversion predefined by the operating system

Tips for converting values


Configuration of the value conversion

Internationalization -> Converting units -> Configuration of the value conversion

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In this tutorial you will now internationalize the measuring unit: Liters are converted to gallons and degrees Celsius to Fahrenheit.

To do so, follow the steps as indicated above:

  • Parameterizing the value conversion
  • Allocating to variable
  • Creating a function
  • Applying the function

Other topics in this chapter

Preparation of the project

Configuration of the Measuring unit

Allocation to a variable

Configuration of the function

Applying measuring units and functions to a button


Preparation of the project

Internationalization -> Converting units -> Configuration of the value conversion -> Preparation of the project

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

If you have been following this tutorial step by step up to this point you will already have carried out some of the following settings. In this case, you can adopt your present work or skip the steps already taken.

  • Select the screen Main
  • Open the screen by double-clicking on the name

Entering text

  • Select the menu bar Elements.
  • Select Static text.
  • Place this text in your screen.
  • In the properties window enter the term @Filling level .
  • In the project manager open the node Language file.
  • Place the cursor in the last row of the column Keyword.
  • Enter the term to be translated Filling level.
  • Confirm the entry with the enter key. The cells of the remaining language files are pre-filled with this entry.
  • Enter the translation in the corresponding column of your language file (nÍvel).
  • Repeat the steps with the term Temperature.
    The translation is: temperatura.

Entering numerical values

In order to make the following configuration of the unit conversion visible add numerical values to your project:

  • Select the menu bar Elements.
  • Select Numerical value.
  • Place this text in your screen.
  • Select the variable Filling level.
  • Repeat these steps with the variable Temperature.

Sample view of the present configuration in the Editor


Configuration of the Measuring unit

Internationalization -> Converting units -> Configuration of the value conversion -> Configuration of the Measuring unit

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  • In the project manager, open the node Variables.
  • Select the entry Measuring units.
  • Create a new basic unit with Basic unit new.
  • In this example liters are to be converted to gallons.
    For this reason, name the basic unit filling quantity.
  • With the help of Converting unit new create the entry Liter.
    To do so, press the symbol or use the right mouse key.
  • Leave the settings in the properties window as defined.
  • Create a second entry and name it Gallons.
  • In the properties window of the entry Gallons change the factor to 0,264172.

Measuring unit conversion with Fahrenheit

  • Repeat these steps for the temperature
  • To do so create a new Basic unit Temperature and
  • two Conversion units Celsius and Fahrenheit

info Information

For converting Celsius to Fahrenheit set the following properties:

Factor: 1.8 and Offset: 32


Allocation to a variable

Internationalization -> Converting units -> Configuration of the value conversion -> Allocation to a variable

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In order to be able to allocate a variable in zenon the following steps must be taken:

  • In the project manager, open the node Variable.
  • Select the variable Temperature.
  • In the properties window in General select the property Measuring unit: .
  • In the drop-down list select the measuring unit Temperature.

  • Repeat this step with the variable Filling level and the measuring unit Filling level.


Configuration of the function

Internationalization -> Converting units -> Configuration of the value conversion -> Configuration of the function

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  • In the project manager, open the node Functions.
  • Create a new function with Function new.
  • In the opening dialog, select the entry Variable unit conversion
    This entry is in the Variable node.
  • In the next dialog box select the drop-down list Change tonext to the basic unit filling quantity.
  • In the drop-down list, change the entry <Basic unit> toGallons.
  • Name this function convert_to_Gallons.
  • Repeat these steps for liters and name the new function convert_to_Liter.


Applying measuring units and functions to a button

Internationalization -> Converting units -> Configuration of the value conversion -> Applying measuring units and functions to a button

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Applying the function unit conversion again is very simple:

  1. Create a button
  2. name the button Liter
  3. pull the function with Drag&Drop over the button
  4. repeat these steps for gallons
  5. test the configuration in the Runtime

info Information

In order to be able to reconstruct the unit calculation in the Runtime the values for filling quantity and temperature must be filled.

To do so, left-click on the numerical value box and enter a Modified spontaneous value, e.g. 20000

Example for setpoint setting:

Of course, it is also possible to translate the button labeling liter with a prefixed
@-symbol and an entry in the language table.


Scripts for summarizing several functions

Internationalization -> Converting units -> Scripts for summarizing several functions

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In the course of this tutorial several functions were created. This chapter deals with the challenge of summarizing several functions in one script.

Summarizing several functions works according to the well-known pattern:

  • Creating a script.
  • Parameterizing the script.
  • Applying the script with the function Execute script.

Example Example

A script is created which summarizes all the functions of one country.

Other topics in this chapter

Configuring a script

Applying a script

Script with online selection

Practical tips scripts


Configuring a script

Internationalization -> Converting units -> Scripts for summarizing several functions -> Configuring a script

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In order to create a script and add functions:

  • In the project manager, open the node Functions.
  • Expand the view and select the entry Scripts.

  • In the detailed view create a new script with Script new.
    In the properties window name it Country_native.
  • In the detailed view press the button Add functions.
  • Name this script Call_German in the properties window.
  • Add the corresponding functions in the function selection dialog.
    Select the corresponding function and press Add.

    Note: A multiple selection of variables is possible by pressing Shift or Strg + mouse click.
  • Repeat these steps for a second script:
    Script name: Call_Portuguese


Applying a script

Internationalization -> Converting units -> Scripts for summarizing several functions -> Applying a script

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

For applying a created script:

  • Create a new function.
  • Open the function group Script.
  • Select Execute script.

  • In the select script dialog that opens, select Country_native
  • Name this newly created script Call_native.
  • Create a new script for changing to Portuguese.

If you draw two new buttons in the image Main and then apply the newly created function you have several functions with one mouse click.


Script with online selection

Internationalization -> Converting units -> Scripts for summarizing several functions -> Script with online selection

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

At the end of the script application you will now learn how to make the selection of your scripts selectable in the Runtime.

  • To do so, follow the exact steps described in the previous chapter.
  • However, select Script with online selection

    in the selection of the script switching function.

  • In the screen Main draw a button Language selection and apply the newly created function to it.
  • Now test your configuration in the Runtime.

info Information

The script function Script with online selection offers the operator of the Runtime a wide range of selections.


Practical tips scripts

Internationalization -> Converting units -> Scripts for summarizing several functions -> Practical tips scripts

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

After having learned how to combine scripts there is a large quantity of applicatoins at your disposal.

Examples:

  • Foreign employees can have the user interface be displayed in their mother tongue.
  • A configuration of individual functions and scripts allows for flexibility and reutilization.
  • Use scripts to summarize standard procedures.
  • Thanks to the use of scripts and the resulting benefits individual functions can be cut down. Administration and clarity are made easier.


Value conversion predefined by the operating system

Internationalization -> Converting units -> Value conversion predefined by the operating system

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Not all value conversions have to be configured.

In zenon, the following values and their display are directly adopted from the operating system:

  • Date format
  • Time format


Tips for converting values

Internationalization -> Converting units -> Tips for converting values

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com
  • For displaying values use a display in units whenever possible. There will be no need for a translation then.
    Example temperature display: The term degree(s) must be translated. The symbol ° however not only is the same symbol in all languages but can also equally be used for Celcius, Fahrenheit and Kelvin.
    Set the corresponding symbol in the properties of the basic unit.
  • Of course you can also add translatable terms with the
    @-symbol when naming the measuring units. Both options are displayed on the screen:

  • Add the corresponding value conversion to every language change function. Otherwise misunderstandings might easily occur.
  • Set the exact unit name as tool tip. In the familiar environment every employee will automatically think in his or her corresponding mother tongue. For trouble-shooting, optimizing the internationalization and for engineers with focus on internationalization the use of this tool tip can significantly make their work easier.
    Make this tool tip translatable, use international denominations also for local projects. Of course you can translate the measuring unit (Celsius in our example) to the corresponding language.


Applying the wizard to existing projects

Internationalization -> Applying the wizard to existing projects

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In this tutorial you learned how to meet potential challenges of working internationally with zenon. However, zenon would not be zenon if there wasn't a built-in way of making these steps easier.

With the help of the built-in wizard you can automatically convert an existing monolingual project to a multilingual one.

info Information

The wizard is only available in English.

Other topics in this chapter

Configuration of a wizard


Configuration of a wizard

Internationalization -> Applying the wizard to existing projects -> Configuration of a wizard

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

To start a wizard:

  • from the menu bar File select the entry Wizards ...

    or

  • press the short cut Alt+F12
  • Select, in the Language table folder, the Language change wizard

  • Select the corresponding entries.
  • Navigate through the wizard with Left arrow and Right arrow.
  • The wizard is executed with the button SAVE! at the Save language table page of the wizard
  • To end the wizard press Cancel.

In the language table of the project all existing language-changeable keywords are listed.

info Information

After ending the wizard all language-changeable keywords contained in a project are listed.


Translation assistance Project Translation Interface

Internationalization -> Translation assistance Project Translation Interface

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In order to be able to translate multilingual texts efficiently and fast zenon offers and external translation tool as of version 7.10 or higher.

This works in conjunction with the Language Translation Wizard:

  • The wizard serves for exporting and processing multilingual contents configured in zenon.
  • The Project Translation Interface supports the translator by displaying the configured screens as well as markers for text lengths.
  • When the translation is complete the wizard will re-import the data to zenon.


Message Control (subject to license)

Internationalization -> Message Control (subject to license)

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Make sure you also create the entry Dynamic part of the subject language-dependent in the properties for the node Message Control.

Please also bear in mind that there are international standards when you configure the user administration. If you make a habit of always entering telephone numbers with their international prefix you will be perfectly prepared for later extensions.

Please also adhere to the requirements of the corresponding telephone system, such as dialling a "0 for exchange line".
Set these entries at: User administration=> User=> Button User new => Tab Message Control

attention Attention

In case of voice messages bear in mind that the connected telephone for voice messages has the required authorizations (e.g. international calls).

Other topics in this chapter

Language-dependent texts in Message Control


Language-dependent texts in Message Control

Internationalization -> Message Control (subject to license) -> Language-dependent texts in Message Control

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

Remember to also internationalize outgoing messages.

User administration and Message Control are working together:

  • The contact information of the recipients is entered into the settings of the user administration.
  • Language groups can be created with the help of user groups.
  • The mailing type of the Message Control is added to the corresponding recipient

Other topics in this chapter

Configuration of the Message Control

Practical tips for language-dependent Message Control


Configuration of the Message Control

Internationalization -> Message Control (subject to license) -> Language-dependent texts in Message Control -> Configuration of the Message Control

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In order to transmit a message:

  1. In the project manager, open the node Message Control
  2. In the properties window in the entry Dynamic part of the subject: enter the corresponding text. Make sure that there is an @-symbol in front of your text.
    In this example enter @Example text for the subject in Message Control .
  3. In the project manager change to the node language file and enter this sentence as new keyword.
  4. Next, create the corresponding function:
    To do so, in the function group Message Control select the function Send message
  5. Parameterize this function in the tab Message by entering@Text message in the module Message Control in the box Free message text

    Note: A multiple selection is possible in the allocation of the recipient name in the tab Mailing type=> Recipient name=> ....
    In the language file create the corresponding translation for your message text.
    Translation for this tutorial: xxx


Practical tips for language-dependent Message Control

Internationalization -> Message Control (subject to license) -> Language-dependent texts in Message Control -> Practical tips for language-dependent Message Control

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

In order to be able to adapt the language of the outgoing message to the recipient create language-dependent user groups in the user administration. These groups can be created in addition to existing groups.

If you are working with this method it is recommended to put a corresponding labeling in front of the name when naming a group:


Application opportunities of the language change

Internationalization -> Application opportunities of the language change

Previous chapter Next chapter Display all Display all Hide all Hide all
© Ing. Punzenberger COPA-DATA GmbH. For any questions regarding the documentation please contact: documentation@copadata.com

The language change option is not limited to the classic language change only. Here are a few examples of how you can also use the multilingualism:

  • Tool tips
  • Menus
  • Alarm Message List
  • Chronological Event Lists

For the image types supplied by zenon as well as the dialogs used in Runtime and Editor you can request translated language tables from support@copadata.com.

The following language tables are available:

  • English
  • French
  • Italian
  • Russian
  • Spanish


Summary

Internationalization -> Summary

After having this tutorial completed you will know how to configure international projects efficiently and with little effort with zenon. Have fun!

Recommended chapters of the Online Help

For further information read the corresponding chapters in the online help.

The links mentioned will give you an overview over the information in this tutorial.

  • Editor
    Description
  • Basic Tutorial
  • Project and workspace
  • Project efficiently with the help of zenon
  • Screens
  • Functions
  • Scripts
  • Language switch
  • Message Control
  • Measuring unit conversion
  • Wizard: Language change